package ru.indvdum.mywork.openjpa.model;

import javax.persistence.Column;
import javax.persistence.EmbeddedId;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.ManyToOne;
import javax.persistence.MapsId;
import javax.persistence.Table;

/**
 * @author indvdum
 * 16.08.2011 13:55:51
 *
 */
@Entity
@Table(name = "WORK")
public class Work implements IDatabaseObject {

	private static final long serialVersionUID = 7138260708537798813L;
	
	@EmbeddedId
	WorkId id;
	
	@Column(name = "HOURS")
	private Float hours = null;
	
	@Column(name = "RESULT")
	private String result = null;
	
	@MapsId("dayId")
	@ManyToOne(fetch = FetchType.EAGER)
	private Day day = null;
	
	@MapsId("taskId")
	@ManyToOne(fetch = FetchType.EAGER)
	private Task task = null;
	
	public Work(){
		
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (!(obj instanceof Work))
			return false;
		final Work other = (Work) obj;
		return (
				this.day == other.day 
				&& this.task == other.task 
				|| (
						this.day != null 
						&& this.day.equals(other.day) 
						&& this.task != null 
						&& this.task.equals(other.task)
						)
				);
	}

	public Float getHours() {
		return hours;
	}

	public void setHours(Float hours) {
		this.hours = hours;
	}

	public String getResult() {
		return result;
	}

	public void setResult(String result) {
		this.result = result;
	}

	public Day getDay() {
		return day;
	}

	public void setDay(Day day) {
		this.day = day;
	}

	public Task getTask() {
		return task;
	}

	public void setTask(Task task) {
		this.task = task;
	}

	public String getDayName() {
		return getDay().getDay().toString();
	}
	
	public String getTaskName() {
		return getTask().getName();
	}

}
